from polybori import *
from Katan32 import *
from utilities import *

global irregular
irregular = [1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 0, 1, 0, 1, 0,
             1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 0,
             1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 1, 0, 0, 0, 1,
             1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0,
             0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0,
             1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 1, 0, 0,
             0, 0, 1, 1, 0, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1,
             1, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 1, 0, 1, 0, 0, 1,
             1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 0, 1, 1, 1,
             0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 1, 0, 1, 1, 0, 1, 1,
             0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0,
             1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1,
             0, 1, 0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 1, 0, 0, 0,
             0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1,
             0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0]
    
def twoKatan(pR, KE, plain, rounds=254, faultRound=237):
  '''
  calculating the symbolic difference from two katan implementations
  '''
  #generating the systems
  for pos in range(32):
    origOutput, origKatan = oneKatan32enc(rounds, pR, plain)
    faultOutput, faultKatan, fault_pos, faultSys = faultKatan32(rounds, faultRound, pR, plain, pos)
    #assert len(origKatan) == len(faultKatan) and len(origOutput)==len(faultOutput), 'the equation system have not the same length'
    #for f in faultSys:
    #  print f
    fullSys=faultSys + origKatan + origOutput + faultOutput + faultKatan
    #fullSys=origKatan + origOutput
    #for f in faultKatan:
    #  print f
    #for f in faultOutput:
    #  print f
    #for f in faultSys:
    #  print f

    #fullSys += faultKatan+faultOutput

    #print 'length of the system: ', len(origKatan)

    #adding up the instances
    delta=set()
    deltaOuput=[]
    nonFaultDelta=[  pR('zF_00 + zD_00'),  pR('bD_0247*bD_0244 + zF_01 + zD_01 + bD_0240 + bD_0245 + bD_0249 + aD_0253 + k504'),  pR('bD_0246*bD_0243 + zF_02 + zD_02 + bD_0239 + bD_0244 + aD_0252 + k502'),  pR('bD_0245*bD_0242 + zF_03 + zD_03 + bD_0238 + bD_0243 + aD_0251 + k500'),  pR('bD_0244*bD_0241 + zF_04 + zD_04 + bD_0237 + bD_0242 + bD_0246 + aD_0250 + k498'),  pR('zF_05 + zD_05'),  pR('zF_06 + zD_06'),  pR('zF_07 + zD_07'),  pR('zF_08 + zD_08'),  pR('zF_09 + zD_09'),  pR('zF_10 + zD_10'),  pR('zF_11 + zD_11'),  pR('zF_12 + zD_12'),  pR('zF_13 + zD_13'),  pR('zF_14 + zD_14'),  pR('zF_15 + zD_15'),  pR('zF_16 + zD_16'),  pR('zF_17 + zD_17'),  pR('zF_18 + zD_18'),  pR('aD_0245*bD_0244*bD_0241 + aD_0245*bD_0237 + aD_0245*bD_0242 + bD_0246*aD_0245 + aD_0250*aD_0245 + k498*aD_0245 + zF_19 + zD_19'),  pR('aD_0242*aD_0240 + aD_0249*aD_0244 + zF_20 + zD_20 + aD_0234 + aD_0245 + bD_0253 + k505'),  pR('aD_0241*aD_0239 + aD_0248*aD_0243 + zF_21 + zD_21 + aD_0233 + aD_0244 + bD_0252 + k503'),  pR('aD_0240*aD_0238 + aD_0247*aD_0242 + zF_22 + zD_22 + aD_0232 + aD_0243 + bD_0251 + k501'),  pR('aD_0239*aD_0237 + aD_0246*aD_0241 + zF_23 + zD_23 + aD_0231 + aD_0242 + bD_0250 + k499'),  pR('zF_24 + zD_24'),  pR('zF_25 + zD_25'),  pR('zF_26 + zD_26'),  pR('zF_27 + zD_27'),  pR('zF_28 + zD_28'),  pR('zF_29 + zD_29'),  pR('zF_30 + zD_30'),  pR('zF_31 + zD_31')]  
    #for i in xrange(len(origKatan)):  
    #  delta.add(origKatan[i]+faultKatan[i])
    for i in xrange(32):
      deltaOuput.append(origOutput[i]+faultOutput[i])
    for i in xrange(32):
      deltaOuput[i]+=nonFaultDelta[i]
    print pos
    for f in deltaOuput:
      print f,
    fullSys+=delta
    #non-symbolic systems (adding output to the system)
    origC = Katan32enc(plain, rounds, KE)
    faultC = Katan32fault(plain, rounds, faultRound, fault_pos, KE)

  #for i in xrange(32):
  #  print origC[i] + faultC[i]
  fullSys += [ 'zD_%02d+%s'%(i, str(origC[i])) for i in range(32) ] 
  fullSys += [ 'zF_%02d+%s'%(i, str(faultC[i])) for i in range(32) ]
  return fullSys

def twoKatanVec(pR, KE, plain, rounds=254, faultRound=237, fault_vec=None, fake_Vec=None):
  '''
  calculating the symbolic difference from two katan implementations
  '''
  #generating the systems
  for pos in range(30):
    vec = [pos, pos + 1, pos + 2]
    origOutput, origKatan = oneKatan32enc(rounds, pR, plain)
    faultOutput, faultKatan, fault_pos, faultSys = faultKatan32Vec(rounds, faultRound, pR, plain, vec)
    #assert len(origKatan) == len(faultKatan) and len(origOutput)==len(faultOutput), 'the equation system have not the same length'
    #for f in faultSys:
    #  print f
    fullSys=faultSys + origKatan + origOutput + faultOutput + faultKatan
    #fullSys=origKatan + origOutput
    #for f in faultKatan:
    #  print f
    #for f in faultOutput:
    #  print f
    #for f in faultSys:
    #  print f

    #fullSys += faultKatan+faultOutput

    #print 'length of the system: ', len(origKatan)

    #adding up the instances
    delta=set()
    deltaOuput=[]
    nonFaultDelta=[  pR('zF_00 + zD_00'),  pR('bD_0247*bD_0244 + zF_01 + zD_01 + bD_0240 + bD_0245 + bD_0249 + aD_0253 + k504'),  pR('bD_0246*bD_0243 + zF_02 + zD_02 + bD_0239 + bD_0244 + aD_0252 + k502'),  pR('bD_0245*bD_0242 + zF_03 + zD_03 + bD_0238 + bD_0243 + aD_0251 + k500'),  pR('bD_0244*bD_0241 + zF_04 + zD_04 + bD_0237 + bD_0242 + bD_0246 + aD_0250 + k498'),  pR('zF_05 + zD_05'),  pR('zF_06 + zD_06'),  pR('zF_07 + zD_07'),  pR('zF_08 + zD_08'),  pR('zF_09 + zD_09'),  pR('zF_10 + zD_10'),  pR('zF_11 + zD_11'),  pR('zF_12 + zD_12'),  pR('zF_13 + zD_13'),  pR('zF_14 + zD_14'),  pR('zF_15 + zD_15'),  pR('zF_16 + zD_16'),  pR('zF_17 + zD_17'),  pR('zF_18 + zD_18'),  pR('aD_0245*bD_0244*bD_0241 + aD_0245*bD_0237 + aD_0245*bD_0242 + bD_0246*aD_0245 + aD_0250*aD_0245 + k498*aD_0245 + zF_19 + zD_19'),  pR('aD_0242*aD_0240 + aD_0249*aD_0244 + zF_20 + zD_20 + aD_0234 + aD_0245 + bD_0253 + k505'),  pR('aD_0241*aD_0239 + aD_0248*aD_0243 + zF_21 + zD_21 + aD_0233 + aD_0244 + bD_0252 + k503'),  pR('aD_0240*aD_0238 + aD_0247*aD_0242 + zF_22 + zD_22 + aD_0232 + aD_0243 + bD_0251 + k501'),  pR('aD_0239*aD_0237 + aD_0246*aD_0241 + zF_23 + zD_23 + aD_0231 + aD_0242 + bD_0250 + k499'),  pR('zF_24 + zD_24'),  pR('zF_25 + zD_25'),  pR('zF_26 + zD_26'),  pR('zF_27 + zD_27'),  pR('zF_28 + zD_28'),  pR('zF_29 + zD_29'),  pR('zF_30 + zD_30'),  pR('zF_31 + zD_31')]  
    #for i in xrange(len(origKatan)):  
    #  delta.add(origKatan[i]+faultKatan[i])
    for i in xrange(32):
      deltaOuput.append(origOutput[i]+faultOutput[i])
    for i in xrange(32):
      deltaOuput[i]+=nonFaultDelta[i]
    print pos
    for f in deltaOuput:
      print f,
    fullSys+=delta
    #non-symbolic systems (adding output to the system)
    origC = Katan32enc(plain, rounds, KE)
    faultC = Katan32faultVec(plain, vec, rounds, faultRound, KE)

  #for i in xrange(32):
  #  print origC[i] + faultC[i]
  fullSys += [ 'zD_%02d+%s'%(i, str(origC[i])) for i in range(32) ] 
  fullSys += [ 'zF_%02d+%s'%(i, str(faultC[i])) for i in range(32) ]
  return fullSys

def oneKatan32enc(rounds, pR, plain):
  """
  a research only implementation of katan32.
  INPUT:
    plan - the plaintext in \F_2. least signicant first (default: None)
    rounds - the number of rounds
    full_key - key for the cipher in \F_2. None for symbolic (default: None)
  """
  def key_schedule(curRound):
    #producing new output
    F.append(k[curRound] + key_lfsr[0])
    key_lfsr[0] = k[curRound]

    #calculating the new bit
    new_bit = key_lfsr[0]+key_lfsr[19]+key_lfsr[30]+key_lfsr[67]

    #shifting the lfsr
    key_lfsr[:79] = key_lfsr[1:]
    key_lfsr[79] = new_bit

    return k[curRound]

  def update_state(key, curRound):#updates the symbolic state
    #setting new variables
    F.append(a[curRound] + L2[0])
    F.append(b[curRound] + L1[0])
    L2[0] = a[curRound]
    L1[0] = b[curRound]

    #updating; the key is a dictionary a:k_a, b:k_b
    f_a = L1[12] + L1[7] + L1[8]*L1[5] + L1[3]*irregular[curRound] + key['a']
    f_b = L2[18] + L2[7] + L2[12]*L2[10] + L2[8]*L2[3] + key['b']
    
    # shift all registers by 1  
    L1[1:] = L1[:12]
    L1[0] = f_b
    L2[1:] = L2[:18]
    L2[0] = f_a

  #loading the variables
  allVars=pR.gens()
  p = sorted([ v for v in allVars if str(v)[0] == "p"], key=lambda k: str(k))
  x = sorted([ v for v in allVars if str(v)[0] == "x"], key=lambda k: str(k))
  k = sorted([ v for v in allVars if str(v)[0] == "k"], key=lambda l: str(l))
  z = sorted([ v for v in allVars if str(v)[:2] == "zD"], key=lambda k: str(k))
  global a,b
  a = sorted([ v for v in allVars if str(v)[:2] == "aD"], key=lambda k: int(str(k)[3:]))
  b = sorted([ v for v in allVars if str(v)[:2] == "bD"], key=lambda k: int(str(k)[3:]))
  
  #setting up the array for the system of equations
  global F
  F = []

  #loading the plaintext in the registers of size 13 and 19 respectively
  global L1,L2
  L1 = plain[19:]
  L2 = plain[:19]

  #LFSR for the key schedule; lsb first
  global key_lfsr
  key_lfsr = x
  
  for curRound in xrange(rounds):
    #clocking the key_lfsr twice
    key = {}
    key['a'] = key_schedule(2*curRound)
    key['b'] = key_schedule(2*curRound+1)
    update_state(key, curRound)
  
  #output generation
  output = L2+L1
  for i in range(32):
    output[i]+=z[i]
  return output, F

def faultKatan32(rounds, faultRound, pR, plain, fault_pos):
  """
  a research only implementation of katan32.
  INPUT:
    faultRound - the round in which the fault is inserted. No fault .. -1 (default: -1)
    plan - the plaintext in \F_2. least signicant first (default: None)
    rounds - the number of rounds
    full_key - key for the cipher in \F_2. None for symbolic (default: None)
  """
  def key_schedule(curRound):
    #producing new output
    F.append(k[curRound] + key_lfsr[0])
    key_lfsr[0] = k[curRound]

    #calculating the new bit
    new_bit = key_lfsr[0]+key_lfsr[19]+key_lfsr[30]+key_lfsr[67]

    #shifting the lfsr
    key_lfsr[:79] = key_lfsr[1:]
    key_lfsr[79] = new_bit

    return k[curRound]

  def update_state(key, curRound, faultRound):#updates the symbolic state
    #setting new variables
    if curRound < faultRound:
      F.append(a[curRound] + L2[0])
      F.append(b[curRound] + L1[0])
      L2[0] = a[curRound]
      L1[0] = b[curRound]
    #else:
      #F.append(aF[curRound] + L2[0])
      #F.append(bF[curRound] + L1[0])
      ##print aF[curRound-faultRound+32] + L2[0]
      ##print bF[curRound-faultRound+32] + L1[0]
      #L2[0] = aF[curRound]
      #L1[0] = bF[curRound]

  
    #updating; the key is a dictionary a:k_a, b:k_b
    f_a = L1[12] + L1[7] + L1[8]*L1[5] + L1[3]*irregular[curRound] + key['a']
    f_b = L2[18] + L2[7] + L2[12]*L2[10] + L2[8]*L2[3] + key['b']
    
    # shift all registers by 1  
    L1[1:] = L1[:12]
    L1[0] = f_b
    L2[1:] = L2[:18]
    L2[0] = f_a

  #loading the variables
  allVars=pR.gens()
  x = sorted([ v for v in allVars if str(v)[0] == "x"], key=lambda k: str(k))
  k = sorted([ v for v in allVars if str(v)[0] == "k"], key=lambda l: str(l))
  z = sorted([ v for v in allVars if str(v)[:2] == "zF"], key=lambda k: str(k))
  global a,b,aF,bF
  a = sorted([ v for v in allVars if str(v)[:2] == "aD"], key=lambda k: int(str(k)[3:]))
  aF = sorted([ v for v in allVars if str(v)[:2] == "aF"], key=lambda k: int(str(k)[3:]))
  b = sorted([ v for v in allVars if str(v)[:2] == "bD"], key=lambda k: int(str(k)[3:]))
  bF = sorted([ v for v in allVars if str(v)[:2] == "bF"], key=lambda k: int(str(k)[3:]))
  #setting up the array for the system of equations
  global F
  F = []
  faultF = []

  #loading the plaintext in the registers of size 13 and 19 respectively
  global L1,L2
  L1 = plain[19:]
  L2 = plain[:19]

  #LFSR for the key schedule; lsb first
  global key_lfsr
  key_lfsr = x
    
  for curRound in xrange(rounds):
    if faultRound==curRound:
      #inserting fault
      #fault_pos = ZZ.random_element(32)
      #print 'def fp', fault_pos
      
      #inserting fault
      if fault_pos < 13:
        L1[fault_pos] += 1
      else:
        L2[fault_pos-13] += 1#clocking the key_lfsr twice
      
    #clocking the key_lfsr twice
    key = {}
    key['a'] = key_schedule(2*curRound)
    key['b'] = key_schedule(2*curRound+1)
    update_state(key, curRound, faultRound)
  
  #output generation
  output = L2 + L1
  for i in range(32):
    output[i]+=z[i]
  return output, F, fault_pos, faultF

def faultKatan32Vec(rounds, faultRound, pR, plain, fault_vec):
  """
  a research only implementation of katan32.
  INPUT:
    faultRound - the round in which the fault is inserted. No fault .. -1 (default: -1)
    plan - the plaintext in \F_2. least signicant first (default: None)
    rounds - the number of rounds
    full_key - key for the cipher in \F_2. None for symbolic (default: None)
  """
  def key_schedule(curRound):
    #producing new output
    F.append(k[curRound] + key_lfsr[0])
    key_lfsr[0] = k[curRound]

    #calculating the new bit
    new_bit = key_lfsr[0]+key_lfsr[19]+key_lfsr[30]+key_lfsr[67]

    #shifting the lfsr
    key_lfsr[:79] = key_lfsr[1:]
    key_lfsr[79] = new_bit

    return k[curRound]

  def update_state(key, curRound, faultRound):#updates the symbolic state
    #setting new variables
    if curRound < faultRound:
      F.append(a[curRound] + L2[0])
      F.append(b[curRound] + L1[0])
      L2[0] = a[curRound]
      L1[0] = b[curRound]
    #else:
      #F.append(aF[curRound] + L2[0])
      #F.append(bF[curRound] + L1[0])
      ##print aF[curRound-faultRound+32] + L2[0]
      ##print bF[curRound-faultRound+32] + L1[0]
      #L2[0] = aF[curRound]
      #L1[0] = bF[curRound]

  
    #updating; the key is a dictionary a:k_a, b:k_b
    f_a = L1[12] + L1[7] + L1[8]*L1[5] + L1[3]*irregular[curRound] + key['a']
    f_b = L2[18] + L2[7] + L2[12]*L2[10] + L2[8]*L2[3] + key['b']
    
    # shift all registers by 1  
    L1[1:] = L1[:12]
    L1[0] = f_b
    L2[1:] = L2[:18]
    L2[0] = f_a

  #loading the variables
  allVars=pR.gens()
  x = sorted([ v for v in allVars if str(v)[0] == "x"], key=lambda k: str(k))
  k = sorted([ v for v in allVars if str(v)[0] == "k"], key=lambda l: str(l))
  z = sorted([ v for v in allVars if str(v)[:2] == "zF"], key=lambda k: str(k))
  global a,b,aF,bF
  a = sorted([ v for v in allVars if str(v)[:2] == "aD"], key=lambda k: int(str(k)[3:]))
  aF = sorted([ v for v in allVars if str(v)[:2] == "aF"], key=lambda k: int(str(k)[3:]))
  b = sorted([ v for v in allVars if str(v)[:2] == "bD"], key=lambda k: int(str(k)[3:]))
  bF = sorted([ v for v in allVars if str(v)[:2] == "bF"], key=lambda k: int(str(k)[3:]))
  #setting up the array for the system of equations
  global F
  F = []
  faultF = []

  #loading the plaintext in the registers of size 13 and 19 respectively
  global L1,L2
  L1 = plain[19:]
  L2 = plain[:19]

  #LFSR for the key schedule; lsb first
  global key_lfsr
  key_lfsr = x
    
  for curRound in xrange(rounds):
    if faultRound==curRound:
      #inserting fault
      #fault_pos = ZZ.random_element(32)
      #print 'def fp', fault_pos
      
      #inserting fault
      for fault_pos in fault_vec:
        if fault_pos < 13:
          L1[fault_pos] += 1
        else:
          L2[fault_pos-13] += 1#clocking the key_lfsr twice
      
    #clocking the key_lfsr twice
    key = {}
    key['a'] = key_schedule(2*curRound)
    key['b'] = key_schedule(2*curRound+1)
    update_state(key, curRound, faultRound)
  
  #output generation
  output = L2 + L1
  for i in range(32):
    output[i]+=z[i]
  return output, F, fault_pos, faultF
